--------------------------------------------------------------------------------
-- Weapon BFG9000 +Projectile ball by Vectar666
-- Based on:
-- Weapon Plasma Blaster + Projectile Ray
-- Original Carnage Contest Weapon
-- Script by DC, December 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------
-- Thanks to Farnsworth for helping with "direction" function!
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.d3==nil then cc.d3={} end
cc.d3.bfg={}
cc.d3.bfg.ball={}

-- Load & Prepare Ressources
cc.d3.bfg.gfx_wpn=loadgfx("weapons/d3_BFG9K.bmp")			-- Weapon Image
setmidhandle(cc.d3.bfg.gfx_wpn)
cc.d3.bfg.gfx_pro=loadgfx("weapons/d3_bfg_shot.bmp")				-- Projectile Image
setmidhandle(cc.d3.bfg.gfx_pro)
cc.d3.bfg.gfx_arc=loadgfx("weapons/d3_bfgarc.bmp")
sethandle(cc.d3.bfg.gfx_arc,0,5)
cc.d3.bfg.sfx_charge=loadsfx("d3_bfg_firebegin.wav")
cc.d3.bfg.sfx_attack=loadsfx("d3_BFG9K.wav")						-- Attack Sound
cc.d3.bfg.sfx_impact=loadsfx("d3_bfg_explode.wav")				-- Impact Sound
cc.d3.bfg.sfx_arc={}
for i=1,3 do
	cc.d3.bfg.sfx_arc[i]=loadsfx("d3_bfg_arc"..i..".wav")
end

--------------------------------------------------------------------------------
-- Weapon: Plasma Blaster
--------------------------------------------------------------------------------

cc.d3.bfg.id=addweapon("cc.d3.bfg","BFG 9000",cc.d3.bfg.gfx_wpn,0,3)	-- Add Weapon (0 uses, first in round 3)
cc.d3.bfg.ammo=4													-- 3 Shots

function cc.d3.bfg.draw()										-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(cc.d3.bfg.gfx_wpn,8,0)
	-- HUD ammobar
	if cc.d3.bfg.ammo-weapon_shots>0 then
		hudammobar(cc.d3.bfg.ammo-weapon_shots,cc.d3.bfg.ammo)
	end
	-- HUD Crosshair
	if cc.d3.bfg.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
	if weapon_charge>0 and weapon_shots<4 then
		hudchargebar(weapon_charge,116)
	end
end

function cc.d3.bfg.attack(attack)								-- Attack
	-- Decrement timer
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if (weapon_shots<cc.d3.bfg.ammo) then
		if (attack==1) and (weapon_timer<=0) then
			if weapon_charge==0 then
				playsound(cc.d3.bfg.sfx_charge,5)
			end
			weapon_charge=weapon_charge+1							-- Increase charge
		end
		-- Attack
		if (attack==0 and weapon_charge>0) or (weapon_charge>=116) then
			stopchannel(5)
			dmg=math.ceil(weapon_charge/29)
			if cc.d3.bfg.ammo-weapon_shots<dmg then dmg=cc.d3.bfg.ammo-weapon_shots end
			weapon_charge=0
			-- No more weapon switching!
			useweapon(0)
			-- Reset Timer
			weapon_timer=50
			-- Attack
			playsound(cc.d3.bfg.sfx_attack)
			weapon_shots=weapon_shots+dmg
			id=createprojectile(cc.d3.bfg.ball.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
			projectiles[id].y=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*6.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*6.0
			-- Timer
			projectiles[id].timer=0
			projectiles[id].arctimer=0
			-- Initial movement
			projectiles[id].x=projectiles[id].x-projectiles[id].sx*1.5
			projectiles[id].y=projectiles[id].y-projectiles[id].sy*1.5
			-- Dmg
			projectiles[id].dmg=dmg
			-- players damaged by arc
			projectiles[id].pls={}
			for i=1,3,1 do
				if cc.d3.bfg.ball.move(id)==1 then
					break
				end
			end
			-- Effects
			recoil(3)
			particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
			particlecolor(0,255,0)
			particlefadealpha(0.01)
			particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
			particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
			particlefadealpha(0.005)
			-- End Turn
			if (weapon_shots>=cc.d3.bfg.ammo) then
				endturn()
			end
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: Ray
--------------------------------------------------------------------------------
--helper functions
function distance(x1,y1,x2,y2)
	return math.sqrt((x1-x2)^2+(y1-y2)^2)
end

function direction(x1,y1,x2,y2)
	return math.deg(math.atan2(y2-y1,x2-x1))
end

function tablecontains(t,value)
    for i=1,#t do
        if t[i]==value then
            return true
        end
    end
	return false
end


cc.d3.bfg.ball.id=addprojectile("cc.d3.bfg.ball")			-- Add Projectile

function cc.d3.bfg.ball.draw(id)								-- Draw
	-- Setup draw mode
	setblend(blend_light)
	setalpha(1)
	setcolor(0,255,0)
	setscale(0.9,0.9)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(cc.d3.bfg.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
	-- Draw arc
	if table.maxn(projectiles[id].pls)>0 then
		for i=1,table.maxn(projectiles[id].pls) do
			setblend(blend_light)
			setalpha(1)
			setcolor(0,255,0)
			setscale((distance(projectiles[id].x,projectiles[id].y,getplayerx(projectiles[id].pls[i]),getplayery(projectiles[id].pls[i])))/80,0.9)
			setrotation(direction(projectiles[id].x,projectiles[id].y,getplayerx(projectiles[id].pls[i]),getplayery(projectiles[id].pls[i])))
			drawimage(cc.d3.bfg.gfx_arc,projectiles[id].x,projectiles[id].y)
		end
	end
end

function cc.d3.bfg.ball.update(id)							-- Update
	-- Move
	cc.d3.bfg.ball.move(id)
end

function cc.d3.bfg.ball.move(id)
	-- Timer (free after 10 secs)
	projectiles[id].timer=projectiles[id].timer+1
	if projectiles[id].timer>500 then
		-- Free projectile
		freeprojectile(id)
		return 1
	end
	
-- Arc (that lightning that hurts other players)
	--timer (arc is hitting player each 2/5 of second
	projectiles[id].arctimer=projectiles[id].arctimer+1
	--Player seek (it finds them without timer)
	apls=playertable(3,0)
	for i=1,#apls do
		if distance(projectiles[id].x,projectiles[id].y,getplayerx(apls[i]),getplayery(apls[i]))<300 and not (tablecontains(projectiles[id].pls,apls[i])) then
			table.insert(projectiles[id].pls,apls[i])
		end
	end
	--dmg
	if projectiles[id].arctimer>=20 then
		if table.maxn(projectiles[id].pls)>0 then
			local ii=0
			for i=1,table.maxn(projectiles[id].pls) do
				if projectiles[id].pls[i-ii]~=nil then
					playerdamage(projectiles[id].pls[i-ii],3*projectiles[id].dmg)
					blood(getplayerx(projectiles[id].pls[i-ii]),getplayery(projectiles[id].pls[i-ii]),1)
					randomseed(ii*i+12345+getframe()*666)
					playsound(cc.d3.bfg.sfx_arc[math.ceil(random(1,3))])
					if getplayerhealth(projectiles[id].pls[i-ii])<=3*projectiles[id].dmg or distance(projectiles[id].x,projectiles[id].y,getplayerx(projectiles[id].pls[i-ii]),getplayery(projectiles[id].pls[i-ii]))>2400 then
						table.remove(projectiles[id].pls,i-ii)
						ii=ii+1
					end
				end
			end
		end
		projectiles[id].arctimer=0
	end
--endarc xD

	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		-- Collision
		if collision(col10x10,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				arealdamage(projectiles[id].x,projectiles[id].y,65+projectiles[id].dmg*4,125*projectiles[id].dmg)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,60+projectiles[id].dmg*10,2)
				-- Crater
				if math.random(1,2)==1 then
					terrainalphaimage(gfx_crater175,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,math.random(6,9)*0.1,0,25,0)
				else
					terrainalphaimage(gfx_crater200,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,math.random(6,9)*0.1,0,25,0)
				end
				-- Effects
				playsound(cc.d3.bfg.sfx_impact)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
				particlefadealpha(1.2)
				particlesize(3.5,3.5)
				particlecolor(0,255,0)
				particlefadealpha(0.005)
				for j=1,30,1 do
					particle(p_lightpuff,projectiles[id].x+math.sin(math.rad(rot))*15,projectiles[id].y-math.cos(math.rad(rot))*15)
					particlespeed(math.random(-20,20)*0.2,math.random(-20,20)*0.2)
					particlefadealpha(0.03)
					particlesize(math.random(40,70)*0.15,math.random(40,70)*0.15)
					particlecolor(0,255,0)
				end
				for i=1,5 do
					particle(p_spark,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
					particlecolor(0,255,0)
					particlefadealpha(0.01)
					particlesize(2.5,2.5)
				end
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			playsound(cc.d3.bfg.sfx_impact)
			particle(p_smoke,projectiles[id].x,projectiles[id].y)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
end