--------------------------------------------------------------------------------
-- Weapon D3 Chainsaw by Vectar666
-- Based on:
-- Weapon Baseball Bat
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------
-- But sound script is mine ;D
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.d3==nil then cc.d3={} end
cc.d3.chainsaw={}

-- Load & Prepare Ressources
cc.d3.chainsaw.gfx_wpn=loadgfx("weapons/d3_chainsaw.bmp")								-- Weapon Image
setmidhandle(cc.d3.chainsaw.gfx_wpn)
cc.d3.chainsaw.sfx_idle=loadsfx("d3_chainsaw_loop_idle.ogg")
cc.d3.chainsaw.sfx_startloop=loadsfx("d3_chainsaw_start_attack.ogg")										-- Attack Sound
cc.d3.chainsaw.sfx_attack=loadsfx("d3_chainsaw_loop_attack.ogg")
cc.d3.chainsaw.sfx_endloop=loadsfx("d3_chainsaw_stop_attack.ogg")
cc.d3.chainsaw.sfx_hit=loadsfx("d3_chainsaw_hit.wav")
cc.d3.chainsaw.sfx_hitterrain=loadsfx("d3_chainsaw_hitterrain.wav")

--------------------------------------------------------------------------------
-- Weapon: baseballbat
--------------------------------------------------------------------------------

cc.d3.chainsaw.id=addweapon("cc.d3.chainsaw","Chainsaw(DooM3)",cc.d3.chainsaw.gfx_wpn,0,2)	-- Add Weapon
cc.d3.chainsaw.ammo=100

function cc.d3.chainsaw.draw()															-- Draw
	-- Decrease Timer (used for animation)
	if weapon_timer>0.0 then
		weapon_timer=weapon_timer-0.5
	end
	-- Draw
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(getplayerdirection(0),1)
		setrotation(getplayerrotation(0))
		drawimage(cc.d3.chainsaw.gfx_wpn,getplayerx(0)+getplayerdirection(0)*5,getplayery(0)+3)
	end
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(5,3)
	end
	if cc.d3.chainsaw.ammo-weapon_shots>0 then
		hudammobar(cc.d3.chainsaw.ammo-weapon_shots,cc.d3.chainsaw.ammo)
	end
	--smoke
	particle(p_smoke,getplayerx(0),getplayery(0)+1)
	particlecolor(10,10,10)
	particlealpha(0.4)
	particlesize(5,3)
	randomseed(12345*666*getframe())
	particlespeed(random(-0.5,0.5),-0.5)
end

function cc.d3.chainsaw.attack(attack)													-- Attack
	if (attack==1) then
		if (weapon_shots<=cc.d3.chainsaw.ammo) then
			particle(p_smoke,getplayerx(0),getplayery(0)+1)
			particlecolor(0,0,0)
			particlealpha(0.5)
			particlesize(6,5)
			randomseed(12345*666*getframe())
			particlespeed(random(-0.5,0.5),-0.5)
			if playedstart==nil then
				playsound(cc.d3.chainsaw.sfx_startloop,5)
				playedstart=1
			else
				if channelplaying(5)==0 then
					playsound(cc.d3.chainsaw.sfx_attack,5)
				end
			end
		else
			if playedend==nil then
				stopchannel(5)
				playsound(cc.d3.chainsaw.sfx_endloop,5)
				playedend=1
			else
				if channelplaying(5)==0 then
					playsound(cc.d3.chainsaw.sfx_idle,5)
				end
			end
		end
		if weapon_timer==0 and (weapon_shots<=cc.d3.chainsaw.ammo) then
			-- No more weapon switching!
			useweapon(0)
			playedend=nil
			weapon_shots=weapon_shots+1
			-- Set timer for animation
			weapon_timer=3
			-- Collision
			col=0
			for dist=5,20,5 do
				for i=-2,2,1 do
					if col==0 then
						if collision(col5x5,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)+(i*10)))*dist,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)+(i*10)))*dist,1,1,0)==1 then
							if playercollision()~=0 and playercollision()~=playercurrent() then
								playerpush(playercollision(),math.sin(math.rad(getplayerrotation(0))),-math.cos(math.rad(getplayerrotation(0))))
								playerdamage(playercollision(),5)
								playsound(cc.d3.chainsaw.sfx_hit)
								blood(getplayerx(playercollision()),getplayery(playercollision()),2)
								col=1
								break
							end
						end
					end
				end
			end
			if col==0 then
				if collision(col5x5,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*10,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10,1,0,0)==1 then
					local gray=math.random(0,20)
					terrainalphaimage(gfx_crater25,getplayerx(0)+getplayerdirection(0)*7+math.sin(math.rad(getplayerrotation(0)))*10,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10,math.random(6,10)*0.1,gray,gray,gray)
					playsound(cc.d3.chainsaw.sfx_hitterrain)
				end
			end
		end
		-- End Turn
		if weapon_shots>=cc.d3.chainsaw.ammo then
			endturn()
		end
	else
		playedstart=nil
		if playedend==nil then
			stopchannel(5)
			playsound(cc.d3.chainsaw.sfx_endloop,5)
			playedend=1
		else
			if channelplaying(5)==0 then
				playsound(cc.d3.chainsaw.sfx_idle,5)
			end
		end
	end
end
