--------------------------------------------------------------------------------
-- Weapon super shotgun (DooM3) by Vectar666
-- Based on:
-- Weapon Pistol
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.d3==nil then cc.d3={} end
cc.d3.ssg={}

-- Load & Prepare Ressources
cc.d3.ssg.gfx_wpn=loadgfx("weapons/d3_dbshotgun.bmp")					-- Weapon Image
sethandle(cc.d3.ssg.gfx_wpn,2,31)
cc.d3.ssg.sfx_attack=loadsfx("d3_ssg.ogg")						-- Attack Sound
cc.d3.ssg.sfx_impact={}
for i=1,3 do
	cc.d3.ssg.sfx_impact[i]=loadsfx("d3_sgric"..i..".wav")
end

--------------------------------------------------------------------------------
-- Weapon: Pistol
--------------------------------------------------------------------------------

cc.d3.ssg.id=addweapon("cc.d3.ssg","Double-Barreled Shotgun",cc.d3.ssg.gfx_wpn,0,2)	-- Add Weapon
cc.d3.ssg.ammo=3												-- 12 Bullets

function cc.d3.ssg.draw()										-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(cc.d3.ssg.gfx_wpn,6,0,0.5)
	-- HUD ammobar
	if cc.d3.ssg.ammo-weapon_shots>0 then
		hudammobar(cc.d3.ssg.ammo-weapon_shots,cc.d3.ssg.ammo)
	end
	-- HUD Crosshair
	if cc.d3.ssg.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function cc.d3.ssg.attack(attack)								-- Attack
	-- Decrement timer
if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	-- Attack
	if weapon_shots<cc.d3.ssg.ammo and weapon_timer<=0 and attack==1 then
		-- No more weapon switching!
		useweapon(0)
		-- Reset Timer
		math.randomseed(weapon_shots*12345*getframe())
		weapon_timer=math.random(110,120)
		-- Attack
		playsound(cc.d3.ssg.sfx_attack)
		weapon_shots=weapon_shots+1
		local bignore=playercurrent()
		for j=1,15 do
			math.randomseed(weapon_shots*12345*j)
			offset=-22.0+math.random()*44.0
			-- Set initial position of projectile
			local bx=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
			local by=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
			-- Set speed of projectile
			local vx=math.sin(math.rad(getplayerrotation(0)+offset))*4
			local vy=-math.cos(math.rad(getplayerrotation(0)+offset))*4
			local cx,cy
			for dist=1,6000 do
				cx=bx+vx*dist
				cy=by+vy*dist
				if collision(col4x4,cx,cy,1,1)==1 then
					if terraincollision()==1 or playercollision()~=bignore then
						-- Cause damage
						if playercollision()~=bignore and playercollision()~=0 then
							playerpush(playercollision(),vx/7.0,vy/7.0)
							playerdamage(playercollision(),14)
							blood(cx,cy,3)
						elseif objectcollision()>0 then
							objectdamage(objectcollision(),14)
						end
						if terraincollision()==1 then
							local gray=math.random(0,20)
							terrainalphaimage(gfx_crater25,cx,cy,math.random(6,10)*0.1,gray,gray,gray)
							terraincircle(cx,cy,4,0x00000000)
						-- Effects
							randomseed(12345*getframesleft()+getframe()*666+cx*cy)
							playsound(cc.d3.ssg.sfx_impact[math.ceil(random(0.5,3))])
						end
						particle(p_smoke,cx,cy)
						particlefadealpha(0.006)
						particle(p_muzzle,cx,cy)
						break
					end
				end
				--water
				if (cy)>getwatery()+5 then
					-- Effects
					particle(p_waterhit,cx,cy)
					if math.random(1,2)==1 then
						playsound(sfx_hitwater2)
					else
						playsound(sfx_hitwater3)
					end
					-- Free projectile
					break
				end
			end
		end
		-- Effects
		recoil(3)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		particlecolor(0,0,0)
		particlesize(10,10)
		-- End Turn
		if (weapon_shots>=cc.d3.ssg.ammo) then
			endturn()
		end
	end
end